Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 13520)
@@ -351,8 +529,18 @@
             this.tableLayoutPanel2.ResumeLayout(false);
             this.tableLayoutPanel2.PerformLayout();
+            this.flowLayoutPanel1.ResumeLayout(false);
+            this.flowLayoutPanel1.PerformLayout();
             this.tabPageImg.ResumeLayout(false);
-            ((System.ComponentModel.ISupportInitialize)(this.picshowImg)).EndInit();
             this.tableLayoutPanel3.ResumeLayout(false);
             this.tableLayoutPanel3.PerformLayout();
+            ((System.ComponentModel.ISupportInitialize)(this.lstConfidentLevelBindingSource)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.modelManagerBaseBindingSource)).EndInit();
+            this.flowLayoutPanel2.ResumeLayout(false);
+            this.flowLayoutPanel2.PerformLayout();
+            this.tabPageRoot.ResumeLayout(false);
+            this.tableLayoutPanel4.ResumeLayout(false);
+            this.tableLayoutPanel4.PerformLayout();
+            ((System.ComponentModel.ISupportInitialize)(this.picshowImg)).EndInit();
+            this.TreeViewCMenu.ResumeLayout(false);
             this.ResumeLayout(false);
             this.PerformLayout();
@@ -371,9 +559,5 @@
         private System.Windows.Forms.TreeView AlbumsTV;
         private System.Windows.Forms.ImageList imageListTV;
-        private System.Windows.Forms.ComboBox cbxLstCatTo;
-        private System.Windows.Forms.Label label4;
-        private System.Windows.Forms.Button button2;
         private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
-        private System.Windows.Forms.BindingSource modelManagerBaseBindingSource;
         private System.Windows.Forms.TabControl tabControl1;
         private System.Windows.Forms.TabPage tabPageAlbum;
@@ -385,6 +569,4 @@
         private System.Windows.Forms.Label label5;
         private System.Windows.Forms.Label label7;
-        private System.Windows.Forms.Button btnAlbumEditCancel;
-        private System.Windows.Forms.Button btnAlbumEditOk;
         private System.Windows.Forms.TableLayoutPanel tableLayoutPanel3;
         private System.Windows.Forms.TextBox txtImgName;
@@ -392,7 +574,33 @@
         private System.Windows.Forms.Label label8;
         private System.Windows.Forms.TextBox txtImgComment;
-        private System.Windows.Forms.Button button3;
-        private System.Windows.Forms.Button button4;
+        private System.Windows.Forms.Button btnImgEditCancel;
+        private System.Windows.Forms.Button btnImgEditOk;
         private System.Windows.Forms.PictureBox picshowImg;
+        private System.Windows.Forms.TextBox txtImgAuthor;
+        private System.Windows.Forms.Label label9;
+        private System.Windows.Forms.FlowLayoutPanel flowLayoutPanel1;
+        private System.Windows.Forms.Button btnAlbumEditCancel;
+        private System.Windows.Forms.Button btnAlbumEditOk;
+        private System.Windows.Forms.Button btnAlbDelete;
+        private System.Windows.Forms.Button btnAlbumAjout;
+        private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
+        private System.Windows.Forms.ContextMenuStrip TreeViewCMenu;
+        private System.Windows.Forms.ToolStripMenuItem toolStripMenuItem1;
+        private System.Windows.Forms.TabPage tabPageRoot;
+        private System.Windows.Forms.TableLayoutPanel tableLayoutPanel4;
+        private System.Windows.Forms.Label label10;
+        private System.Windows.Forms.ComboBox cbImgLevelEnum;
+        private System.Windows.Forms.BindingSource lstConfidentLevelBindingSource;
+        private System.Windows.Forms.BindingSource modelManagerBaseBindingSource;
+        private System.Windows.Forms.TextBox txtOptionAuthor;
+        private System.Windows.Forms.Label label11;
+        private System.Windows.Forms.Label label12;
+        private System.Windows.Forms.ComboBox cbOptionLevel;
+        private System.Windows.Forms.Button button2;
+        private System.Windows.Forms.Label label4;
+        private System.Windows.Forms.ComboBox cbxLstCatTo;
+        private System.Windows.Forms.FlowLayoutPanel flowLayoutPanel2;
+        private System.Windows.Forms.Button btnImgDelete;
+        private System.Windows.Forms.Button btnImgAdd;
     }
 }
Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 13520)
@@ -18,9 +18,16 @@
             InitializeComponent();
             modelManagerBaseBindingSource.DataSource = ModelManager.Instance;
-            
+
+            txtOptionAuthor.DataBindings.Add("Text", ModelManager.Instance.UploadOption, "Author", false, DataSourceUpdateMode.OnPropertyChanged);
+            cbOptionLevel.DataBindings.Add("SelectedValue", ModelManager.Instance.UploadOption, "ConfidentialLevel", false, DataSourceUpdateMode.OnPropertyChanged);
+
             txtAlbName.DataBindings.Add("Text", ModelManager.Instance.AlbumEdited, "Name", false, DataSourceUpdateMode.OnPropertyChanged);
             txtAlbComment.DataBindings.Add("Text", ModelManager.Instance.AlbumEdited, "MessageInfo", false, DataSourceUpdateMode.OnPropertyChanged);
             
             picshowImg.DataBindings.Add("ImageLocation", ModelManager.Instance.ImageEdited, "LocalFile", false, DataSourceUpdateMode.Never);
+            txtImgName.DataBindings.Add("Text", ModelManager.Instance.ImageEdited, "Name", false, DataSourceUpdateMode.OnPropertyChanged);
+            txtImgComment.DataBindings.Add("Text", ModelManager.Instance.ImageEdited, "AuthorComment", false, DataSourceUpdateMode.OnPropertyChanged);
+            txtImgAuthor.DataBindings.Add("Text", ModelManager.Instance.ImageEdited, "Author", false, DataSourceUpdateMode.OnPropertyChanged);
+            cbImgLevelEnum.DataBindings.Add("SelectedValue", ModelManager.Instance.ImageEdited, "ConfidentialLevel", false, DataSourceUpdateMode.OnPropertyChanged);
         }
 
@@ -112,11 +119,9 @@
         }
 
-        private void modelManagerBindingSource_CurrentChanged(object sender, EventArgs e)
-        {
-
-        }
 
         private void AlbumsTV_AfterSelect(object sender, TreeViewEventArgs e)
         {
+
+            ModelManager.Instance.SelectedNode = AlbumsTV.SelectedNode;
             if (e.Node.Tag is LocalAlbum)
             {
@@ -126,4 +131,14 @@
                 ModelManager.Instance.AlbumEdited.LocalDir = alb.LocalDir;
                 ModelManager.Instance.AlbumEdited.MessageInfo = alb.MessageInfo;
+
+                ModelManager.Instance.ImageEdited.Name = String.Empty;
+                ModelManager.Instance.ImageEdited.Id = null;
+                ModelManager.Instance.ImageEdited.Author = String.Empty;
+                ModelManager.Instance.ImageEdited.AuthorComment = String.Empty;
+                ModelManager.Instance.ImageEdited.ConfidentialLevel = 0;
+                ModelManager.Instance.ImageEdited.LocalFile = String.Empty; ;
+                ModelManager.Instance.ImageEdited.LstTags = null;
+                ModelManager.Instance.ImageEdited.UpperCatId = 0;
+
                 tabControl1.SelectedTab = tabPageAlbum;
                 tabControl1.Enabled = true;
@@ -141,4 +156,17 @@
                 ModelManager.Instance.ImageEdited.UpperCatId = img.UpperCatId;
 
+                if ((e.Node.Parent != null)
+                    && (e.Node.Parent.Tag is LocalAlbum))
+                {
+                    LocalAlbum alb = (LocalAlbum)e.Node.Parent.Tag;
+                    if (ModelManager.Instance.AlbumEdited.LocalDir != alb.LocalDir)
+                    {
+                        ModelManager.Instance.AlbumEdited.Name = alb.Name;
+                        ModelManager.Instance.AlbumEdited.Id = alb.Id;
+                        ModelManager.Instance.AlbumEdited.LocalDir = alb.LocalDir;
+                        ModelManager.Instance.AlbumEdited.MessageInfo = alb.MessageInfo;
+                    }
+                }
+
                 tabControl1.SelectedTab = tabPageImg;
                 tabControl1.Enabled = true;
@@ -152,15 +180,51 @@
         }
 
-        private void selectedPwgAlbumListBindingSource_CurrentChanged(object sender, EventArgs e)
-        {
-
-        }
-
-        private void bindingSource1_CurrentChanged(object sender, EventArgs e)
-        {
-
-        }
-
-        private void btnAlbumEditOk_Click(object sender, EventArgs e)
+        private void btnAlbumEditCancel_Click(object sender, EventArgs e)
+        {
+            if (AlbumsTV.SelectedNode.Tag is LocalImage)
+            {
+                LocalImage img = (LocalImage)AlbumsTV.SelectedNode.Tag;
+                if (ModelManager.Instance.ImageEdited.LocalFile == img.LocalFile)
+                {
+                    ModelManager.Instance.ImageEdited.Name = img.Name;
+                    ModelManager.Instance.ImageEdited.Id = img.Id;
+                    ModelManager.Instance.ImageEdited.Author = img.Author;
+                    ModelManager.Instance.ImageEdited.AuthorComment = img.AuthorComment;
+                    ModelManager.Instance.ImageEdited.ConfidentialLevel = img.ConfidentialLevel;
+                    ModelManager.Instance.ImageEdited.LocalFile = img.LocalFile;
+                    ModelManager.Instance.ImageEdited.LstTags = img.LstTags;
+                    ModelManager.Instance.ImageEdited.UpperCatId = img.UpperCatId;
+                }
+            }
+            else
+            {
+                tabControl1.Enabled = false;
+            }
+        }
+
+        private void btnImgEditCancel_Click(object sender, EventArgs e)
+        {
+            if (AlbumsTV.SelectedNode.Tag is LocalImage)
+            {
+                LocalImage img = (LocalImage)AlbumsTV.SelectedNode.Tag;
+                if (ModelManager.Instance.ImageEdited.LocalFile == img.LocalFile)
+                {
+                    img.Name              = ModelManager.Instance.ImageEdited.Name              ;
+                    img.Id                = ModelManager.Instance.ImageEdited.Id                ;
+                    img.Author            = ModelManager.Instance.ImageEdited.Author            ;
+                    img.AuthorComment     = ModelManager.Instance.ImageEdited.AuthorComment     ;
+                    img.ConfidentialLevel = ModelManager.Instance.ImageEdited.ConfidentialLevel ;
+                    img.LocalFile         = ModelManager.Instance.ImageEdited.LocalFile         ;
+                    img.LstTags           = ModelManager.Instance.ImageEdited.LstTags           ;
+                    img.UpperCatId        = ModelManager.Instance.ImageEdited.UpperCatId        ;
+                }
+            }
+            else
+            {
+                tabControl1.Enabled = false;
+            }
+        }
+
+        private void btnImgEditOk_Click(object sender, EventArgs e)
         {
             if (AlbumsTV.SelectedNode.Tag is LocalAlbum)
@@ -179,7 +243,66 @@
                 tabControl1.Enabled = false;
             }
-        }
-
-        private void btnAlbumEditCancel_Click(object sender, EventArgs e)
+
+        }
+
+        private void AlbumsTV_DragEnter(object sender, DragEventArgs e)
+        {
+            if (e.Data.GetDataPresent(DataFormats.FileDrop))
+            {
+                e.Effect = DragDropEffects.Copy;
+            }
+            else
+            {
+                e.Effect = DragDropEffects.None;
+            }
+
+        }
+
+        private void AlbumsTV_DragDrop(object sender, DragEventArgs e)
+        {
+            if (e.Data.GetDataPresent(DataFormats.FileDrop))
+            {
+                string[] filePaths = (string[])(e.Data.GetData(DataFormats.FileDrop));
+                foreach (string fileLoc in filePaths)
+                {
+                    if (File.Exists(fileLoc)
+                        || Directory.Exists(fileLoc) )
+                    {
+                        ModelManager.Instance.directoryName = fileLoc;
+                        ServiceFactory.GetByType<LoadFromDirectory>().runService();
+                    } 
+                }
+                MainAppHelper.BuildAlbumTree(AlbumsTV, ModelManager.Instance.lstAlbumLocaux);
+            }
+        }
+
+        private void btnAlbumAjout_Click(object sender, EventArgs e)
+        {
+            String rootPath = String.Empty;
+            if (AlbumsTV.SelectedNode.Tag is LocalImage)
+            {
+                LocalImage img = (LocalImage)AlbumsTV.SelectedNode.Tag;
+            }
+            else if (AlbumsTV.SelectedNode.Tag is LocalAlbum)
+            {
+                LocalAlbum alb = (LocalAlbum)AlbumsTV.SelectedNode.Tag;
+            }
+
+            folderBrowserDialog1.RootFolder = Environment.SpecialFolder.MyComputer; 
+            folderBrowserDialog1.SelectedPath = rootPath;
+
+            folderBrowserDialog1.ShowNewFolderButton = false;
+
+            if (folderBrowserDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
+            {
+                ModelManager.Instance.directoryName = folderBrowserDialog1.SelectedPath;
+                ServiceFactory.GetByType<LoadFromDirectory>().runService();
+
+                MainAppHelper.BuildAlbumTree(AlbumsTV, ModelManager.Instance.lstAlbumLocaux);
+            }
+            
+        }
+
+        private void btnAlbumEditOk_Click(object sender, EventArgs e)
         {
             if (AlbumsTV.SelectedNode.Tag is LocalAlbum)
@@ -188,13 +311,62 @@
                 if (ModelManager.Instance.AlbumEdited.LocalDir == alb.LocalDir)
                 {
-                    ModelManager.Instance.AlbumEdited.Name = alb.Name;
-                    ModelManager.Instance.AlbumEdited.MessageInfo = alb.MessageInfo;
-                }
-            }
-            else
-            {
-                tabControl1.Enabled = false;
-            }
-        }        
+                    alb.Name = ModelManager.Instance.AlbumEdited.Name;
+                    alb.MessageInfo = ModelManager.Instance.AlbumEdited.MessageInfo;
+
+                    AlbumsTV.SelectedNode.Text = alb.Name;
+                }
+            }
+            else
+            {
+                tabControl1.Enabled = false;
+            }
+        }
+
+        private void btnAlbDelete_Click(object sender, EventArgs e)
+        {
+            if (AlbumsTV.SelectedNode.Tag is LocalAlbum)
+            {
+                LocalAlbum alb = (LocalAlbum)AlbumsTV.SelectedNode.Tag;
+                if (ModelManager.Instance.AlbumEdited.LocalDir == alb.LocalDir)
+                {
+                    LocalDataHelper.DeleteInTree(alb);
+                    TreeNode node = AlbumsTV.SelectedNode;
+                    AlbumsTV.SelectedNode = AlbumsTV.SelectedNode.NextVisibleNode;
+                    node.Tag = null;
+                    node.Remove();
+                }
+            }
+            else
+            {
+                tabControl1.Enabled = false;
+            }
+
+        }
+
+        private void AlbumsTV_MouseDown(object sender, MouseEventArgs e)
+        {
+            if (e.Button == System.Windows.Forms.MouseButtons.Right)
+            {
+                TreeViewCMenu.Show(AlbumsTV.PointToScreen(e.Location));
+            }
+        }
+
+        private void TreeViewCMenu_Click(object sender, EventArgs e)
+        {
+            //ContextMenuStrip cms = (ContextMenuStrip)sender;
+            //cms.
+            MainAppHelper.BuildAlbumTree(AlbumsTV, ModelManager.Instance.lstAlbumLocaux);
+        }
+
+        private void btnImgDelete_Click(object sender, EventArgs e)
+        {
+
+        }
+
+        private void btnImgAdd_Click(object sender, EventArgs e)
+        {
+
+        }
+
     }
-}
+} 
Index: /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 13520)
@@ -75,5 +75,7 @@
     <Compile Include="DTO\LocalPwgImage.cs" />
     <Compile Include="DTO\ModelManager.cs" />
+    <Compile Include="DTO\PwgUploadOption.cs" />
     <Compile Include="DTO\SelectedList.cs" />
+    <Compile Include="Helper\LocalDataHelper.cs" />
     <Compile Include="MainForm.cs">
       <SubType>Form</SubType>
@@ -131,4 +133,10 @@
     <Content Include="Pics\folder_images.png" />
     <Content Include="Pics\image.png" />
+    <Content Include="Resources\agt_update-product.png" />
+    <Content Include="Resources\cancel.png" />
+    <Content Include="Resources\cnrdelete-all.png" />
+    <Content Include="Resources\folder_new.png" />
+    <Content Include="Resources\folder_sent_mail.png" />
+    <Content Include="Resources\lin_agt_wrench.png" />
     <None Include="Resources\image.png" />
     <None Include="Resources\file_broken.png" />
Index: /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 13520)
@@ -5,17 +5,38 @@
 using System.IO;
 using Com.Piwigo.Uploader.DTO;
+using Com.Piwigo.Lib.DTO;
 
 namespace Com.Piwigo.Uploader.Service
 {
+
     public class LoadFromDirectory : IService 
     {
-        string[] extensions = { ".jpeg", ".jpg" };
+        string[] extensions = { ".jpeg", ".jpg", ".JPEG", ".JPG" };
+
+        private LocalImage loadFile(String fileName)
+        {
+            LocalImage img = new LocalImage();
+            // loading image data in album
+            if (extensions.Contains<String>(Path.GetExtension(fileName)))
+            {
+                FileInfo fi = new FileInfo(fileName);
+                img.LocalFile = fi.FullName;
+                img.Name = fi.Name;
+                img.ConfidentialLevel = ModelManager.Instance.UploadOption.ConfidentialLevel;
+                img.Author = ModelManager.Instance.UploadOption.Author;
+                img.AuthorComment = "";
+           }
+            return img;
+        }
 
         private LocalAlbum loadDirectory(String dirName, Int32? rootAlbumId)
         {
-            DirectoryInfo dir = new DirectoryInfo(dirName); 
-            LocalAlbum album = new LocalAlbum (){ LocalDir=dir.FullName, Name=dir.Name};
+            DirectoryInfo dir = new DirectoryInfo(dirName);
+            LocalAlbum album = new LocalAlbum() { LocalDir = dir.FullName, Name = dir.Name };
+
+            Int32 parentAlbumId =  (rootAlbumId.HasValue ? rootAlbumId.Value : PwgAlbum.RootAlbumId);
+
             album.MessageInfo = "";
-            album.UpperCatId = rootAlbumId;
+            album.UpperCatId = parentAlbumId;
             
             // loading image data in album
@@ -24,11 +45,5 @@
                 .Where(s => extensions.Any(ext => ext == Path.GetExtension(s))))
             {
-                FileInfo fi = new  FileInfo(strfile);
-                LocalImage img = new LocalImage();
-                img.LocalFile = fi.FullName;
-                img.Name = fi.Name;
-                img.Author = "";
-                img.AuthorComment = "";
-                album.LocalImages.Add(img);
+                album.LocalImages.Add(loadFile(strfile));
             }
 
@@ -44,8 +59,66 @@
         public void runService()
         {
-            ModelManager.Instance.lstAlbumLocaux.Add(
-                loadDirectory(ModelManager.Instance.directoryName,
-                null)
-                );
+            if (File.Exists(ModelManager.Instance.directoryName))
+            {
+                if (extensions.Contains<String>(Path.GetExtension(ModelManager.Instance.directoryName)))
+                {
+                    FileInfo file = new FileInfo(ModelManager.Instance.directoryName);
+                    LocalAlbum album;
+                    album = ModelManager.Instance.lstAlbumLocaux.SingleOrDefault(a => a.Name == file.Directory.Name);
+
+                    if (album == null)
+                    {
+                        album = new LocalAlbum() { LocalDir = file.Directory.FullName, Name = file.Directory.Name };
+                        album.MessageInfo = "auto created for photo input.";
+                        album.UpperCatId = 0;
+                        album.LocalImages = new LocalImageList();
+                        album.SubAlbums = new LocalAlbumList();
+
+                        ModelManager.Instance.lstAlbumLocaux.Add(album);
+                    }
+
+                    if (album.LocalImages.Count(a => a.Name == file.Name) < 1)
+                    {
+                        album.LocalImages.Add(loadFile(file.FullName));
+                    }
+                }
+            }
+            else if (Directory.Exists(ModelManager.Instance.directoryName))
+            {
+                Int32 RootAlbumId = PwgAlbum.RootAlbumId;
+                LocalAlbum rootAlbum = null;
+
+                if (ModelManager.Instance.SelectedNode != null)
+                {
+                    if (ModelManager.Instance.SelectedNode.Tag != null)
+                    {
+                        if (ModelManager.Instance.SelectedNode.Tag is LocalAlbum)
+                        {
+                            rootAlbum = (LocalAlbum)ModelManager.Instance.SelectedNode.Tag;
+                            RootAlbumId = (rootAlbum.Id.HasValue ? rootAlbum.Id.Value : PwgAlbum.RootAlbumId);
+                        }
+                        else if (ModelManager.Instance.SelectedNode.Tag is PwgImage)
+                        {
+                            rootAlbum = (LocalAlbum)ModelManager.Instance.SelectedNode.Parent.Tag;
+                            RootAlbumId = (rootAlbum.Id.HasValue ? rootAlbum.Id.Value : PwgAlbum.RootAlbumId);
+                        }
+                    }
+                }
+
+                if (rootAlbum != null)
+                {
+                    rootAlbum.SubAlbums.Add(
+                        loadDirectory(ModelManager.Instance.directoryName,
+                        RootAlbumId)
+                        );
+                }
+                else
+                {
+                    ModelManager.Instance.lstAlbumLocaux.Add(
+                        loadDirectory(ModelManager.Instance.directoryName,
+                        PwgAlbum.RootAlbumId)
+                        );
+                }
+            }
         }
     }
Index: /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 13520)
@@ -55,5 +55,9 @@
             FileInfo fi = new FileInfo(aImg.LocalFile);
 
-            List<PwgTag> lstTag = new List<PwgTag>(aImg.LstTags);
+            List<PwgTag> lstTag = new List<PwgTag>();
+            if (aImg.LstTags != null)
+            {
+                lstTag.AddRange(aImg.LstTags);
+            }
 
             PwgServiceProvider.Instance.PwgImagesService.addImageByMultiPartForm(fi, null, aImg.UpperCatId, aImg.Name, aImg.Author, aImg.AuthorComment, aImg.ConfidentialLevel, lstTag);
